--- old/usr/src/uts/intel/amd64/ml/amd64.il	2014-11-14 18:05:27.348271669 -0500
+++ new/usr/src/uts/intel/amd64/ml/amd64.il	2014-11-14 18:05:27.353433796 -0500
@@ -64,15 +64,6 @@
 	.end
 
 /
-/ find the low order bit in a word
-/
-	.inline lowbit,4
-	movq	$-1, %rax
-	bsfq	%rdi, %rax
-	incq	%rax
-	.end
-
-/
 / Networking byte order functions (too bad, Intel has the wrong byte order)
 /
 
--- old/usr/src/uts/intel/asm/bitmap.h	2014-11-14 18:05:27.510300804 -0500
+++ new/usr/src/uts/intel/asm/bitmap.h	2014-11-14 18:05:27.515315962 -0500
@@ -48,29 +48,33 @@
 extern __GNU_INLINE int
 highbit(ulong_t i)
 {
-	long value = -1l;
+	long value;
+	uint8_t zf;
 
 	__asm__(
-	    "bsr" __SUF " %1,%0"
-	    : "+r" (value)
-	    : "r" (i)
+	    "bsr" __SUF " %2,%0;"
+	    "setz %1"
+	    : "=r" (value), "=q" (zf)
+	    : "mr" (i)
 	    : "cc");
 
-	return ((int)(value + 1));
+	return (zf ? 0 : (value + 1));
 }
 
 extern __GNU_INLINE int
 lowbit(ulong_t i)
 {
-	long value = -1l;
+	long value;
+	uint8_t zf;
 
 	__asm__(
-	    "bsf" __SUF " %1,%0"
-	    : "+r" (value)
-	    : "r" (i)
+	    "bsf" __SUF " %2,%0;"
+	    "setz %1"
+	    : "=r" (value), "=q" (zf)
+	    : "mr" (i)
 	    : "cc");
 
-	return ((int)(value + 1));
+	return (zf ? 0 : (value + 1));
 }
 
 extern __GNU_INLINE uint_t
--- old/usr/src/uts/intel/ia32/ml/i86_subr.s	2014-11-14 18:05:27.658349014 -0500
+++ new/usr/src/uts/intel/ia32/ml/i86_subr.s	2014-11-14 18:05:27.663438794 -0500
@@ -2801,7 +2801,8 @@
 
 	ENTRY(lowbit)
 	movl	$-1, %eax
-	bsfq	%rdi, %rax
+	bsfq	%rdi, %rdi
+	cmovnz	%edi, %eax
 	incl	%eax
 	ret
 	SET_SIZE(lowbit)
@@ -2809,10 +2810,13 @@
 #elif defined(__i386)
 
 	ENTRY(lowbit)
-	movl	$-1, %eax
 	bsfl	4(%esp), %eax
+	jz	0f
 	incl	%eax
 	ret
+0:
+	xorl	%eax, %eax
+	ret
 	SET_SIZE(lowbit)
 
 #endif	/* __i386 */
@@ -2825,60 +2829,41 @@
 highbit(ulong_t i)
 { return (0); }
 
+/*ARGSUSED*/
+int
+highbit64(uint64_t i)
+{ return (0); }
+
 #else	/* __lint */
 
 #if defined(__amd64)
 
 	ENTRY(highbit)
+	ALTENTRY(highbit64)
 	movl	$-1, %eax
-	bsrq	%rdi, %rax
+	bsrq	%rdi, %rdi
+	cmovnz	%edi, %eax
 	incl	%eax
 	ret
+	SET_SIZE(highbit64)
 	SET_SIZE(highbit)
 
 #elif defined(__i386)
 
 	ENTRY(highbit)
-	movl	$-1, %eax
 	bsrl	4(%esp), %eax
+	jz	0f
 	incl	%eax
 	ret
+0:
+	xorl	%eax, %eax
+	ret    
 	SET_SIZE(highbit)
 
-#endif	/* __i386 */
-#endif	/* __lint */
-
-#if defined(__lint)
-
-/*ARGSUSED*/
-int
-highbit64(uint64_t i)
-{ return (0); }
-
-#else	/* __lint */
-
-#if defined(__amd64)
-
-	ENTRY(highbit64)
-	movl	$-1, %eax
-	bsrq	%rdi, %rax
-	incl	%eax
-	ret
-	SET_SIZE(highbit64)
-
-#elif defined(__i386)
-
 	ENTRY(highbit64)
 	bsrl	8(%esp), %eax
-	jz	.lowbit
-	addl	$32, %eax
-	jmp	.done
-
-.lowbit:
-	movl	$-1, %eax
-	bsrl	4(%esp), %eax
-.done:
-	incl	%eax
+	jz	highbit
+	addl	$33, %eax
 	ret
 	SET_SIZE(highbit64)
 
--- old/usr/src/uts/intel/ia32/ml/ia32.il	2014-11-14 18:05:27.934547698 -0500
+++ new/usr/src/uts/intel/ia32/ml/ia32.il	2014-11-14 18:05:27.939463803 -0500
@@ -66,24 +66,6 @@
 	.end
 
 /
-/ find the low order bit in a word
-/
-	.inline lowbit,4
-	movl	$-1, %eax
-	bsfl	(%esp), %eax
-	incl	%eax
-	.end
-
-/
-/ find the high order bit in a word
-/
-	.inline highbit,4
-	movl	$-1, %eax
-	bsrl	(%esp), %eax
-	incl	%eax
-	.end
-
-/
 / Networking byte order functions (too bad, Intel has the wrong byte order)
 /
 	.inline	htonll,4
